Last Comment Bug 394859 - Gecko lost its connection with X server
: Gecko lost its connection with X server
Status: RESOLVED FIXED
: crash, verified1.8.1.10
Product: Core Graveyard
Classification: Graveyard
Component: GFX: Gtk (show other bugs)
: 1.8 Branch
: x86 Linux
: -- critical (vote)
: ---
Assigned To: Mats Palmgren (:mats)
:
Mentors:
http://www.photoshopstar.com/graphics...
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-09-04 03:47 PDT by Stephan Klein
Modified: 2009-01-22 10:17 PST (History)
3 users (show)
mats: in‑testsuite?
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
stack (7.37 KB, text/plain)
2007-09-04 04:45 PDT, Mats Palmgren (:mats)
no flags Details
Testcase #1 (297 bytes, text/html)
2007-09-04 05:03 PDT, Mats Palmgren (:mats)
no flags Details
wallpaper (4.00 KB, patch)
2007-09-04 06:17 PDT, Mats Palmgren (:mats)
dbaron: review+
dbaron: superreview+
dveditz: approval1.8.1.10+
Details | Diff | Review
Mochitest.diff (2.69 KB, patch)
2007-11-07 21:51 PST, Mats Palmgren (:mats)
no flags Details | Diff | Review

Description Stephan Klein 2007-09-04 03:47:37 PDT
User-Agent:       Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.6) Gecko/20070827 Ubuntu/7.10 (gutsy) Firefox/2.0.0.6
Build Identifier: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.6) Gecko/20070827 Ubuntu/7.10 (gutsy) Firefox/2.0.0.6

When loading the specified website, the browser crashes, leaving these messages in the command line:

The application 'gecko' lost its connection to the display :0.0; most likely the X server was shut down or you killed/destroyed the application.


With the Html Validator 0.8.4.0 extension enabled, the message looks different:

WARNING: Can not create DiagLog file: /home/stephantom/.mozilla/firefox/21gjiiwn.default/tidy/tidy_last_validated.html
spvalid:2991556152.4011:E: cannot open output file "/home/stephantom/.mozilla/firefox/21gjiiwn.default/tidy/spvalid.err" (Permission denied)
gecko: Fatal IO error 104 (Connection reset by peer) on X server :0.0.

Reproducible: Always

Steps to Reproduce:
1. Open Firefox/2.0.0.6 under Ubuntu Gutsy (Gnome).
2. Load http://www.photoshopstar.com/graphics/professional-glossy-buttons/
3. Crash.
Actual Results:  
The browser crashes.

Expected Results:  
The website should be displayed.
Comment 1 Mats Palmgren (:mats) 2007-09-04 04:45:36 PDT
Created attachment 279586 [details]
stack
Comment 2 Mats Palmgren (:mats) 2007-09-04 05:03:22 PDT
Created attachment 279587 [details]
Testcase #1
Comment 3 Mats Palmgren (:mats) 2007-09-04 05:31:31 PDT
Stephan, what size (in pixels) is your screen?
Comment 4 Stephan Klein 2007-09-04 05:34:50 PDT
My screen is 1280x800, the viewport is 1280x552.
Your testcase crashes me successfully.
Comment 5 Mats Palmgren (:mats) 2007-09-04 06:03:07 PDT
I have 2560x1600.  I was speculating that this bug only occurred for screen
heights >= 1600, but apparently not...
We have code that limits the font size to twice the screen height:
http://bonsai.mozilla.org/cvsblame.cgi?file=/mozilla/gfx/src/gtk/nsFontMetricsXft.cpp&rev=MOZILLA_1_8_BRANCH&root=/cvsroot&mark=250,368#352

FWIW, on my system, the bug occurs for 3200 (which is the value of mPixelSize
after being clamped by the code above).  If I set an absolute limit to 3199
then the bug does not occur...
Comment 6 Mats Palmgren (:mats) 2007-09-04 06:17:36 PDT
Created attachment 279593 [details] [diff] [review]
wallpaper

This fixes it for me.
Comment 7 Mats Palmgren (:mats) 2007-09-04 06:35:08 PDT
Comment on attachment 279593 [details] [diff] [review]
wallpaper

No guaranties it fixes it for everyone, but I think it's low risk
and perhaps worth it for branch.  Feel free to reject it.
Comment 8 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2007-10-03 17:47:33 PDT
Comment on attachment 279593 [details] [diff] [review]
wallpaper

r+sr=dbaron.  Sorry for the delay.
Comment 9 Daniel Veditz [:dveditz] 2007-10-04 14:49:48 PDT
I guess the fact that Mats was able to fix it can be taken as confirmation
Comment 10 Daniel Veditz [:dveditz] 2007-11-07 14:16:43 PST
Comment on attachment 279593 [details] [diff] [review]
wallpaper

approved for 1.8.1.10, a=dveditz for release-drivers
Comment 11 Mats Palmgren (:mats) 2007-11-07 20:05:43 PST
MOZILLA_1_8_BRANCH:
mozilla/gfx/src/gtk/nsFontMetricsGTK.cpp 	1.280.6.4
mozilla/gfx/src/gtk/nsFontMetricsPango.cpp 	1.16.2.8
mozilla/gfx/src/gtk/nsFontMetricsXft.cpp 	1.69.4.3 

-> FIXED
Comment 12 Mats Palmgren (:mats) 2007-11-07 21:51:21 PST
Created attachment 287801 [details] [diff] [review]
Mochitest.diff
Comment 13 Carsten Book [:Tomcat] 2007-11-15 09:58:05 PST
verified fixed 1.8.1.10 using Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.10) Gecko/2007111504 Firefox/2.0.0.10 and the testcase - no crash on testcase

- adding verified keyword
Comment 14 Mats Palmgren (:mats) 2007-12-11 10:39:20 PST
It appears this limit wasn't quite enough in some cases, see bug 394859.
Comment 15 Mats Palmgren (:mats) 2007-12-11 10:39:55 PST
... bug 407842 that is.

Note You need to log in before you can comment on or make changes to this bug.